JavaScriptTokenMaker
Date: 2017-02-11

org.fife.ui.rsyntaxtextarea.modes

## Class JavaScriptTokenMaker

- java.lang.Object
- - org.fife.ui.rsyntaxtextarea.TokenMakerBase
  - - org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker
    - - org.fife.ui.rsyntaxtextarea.AbstractJFlexCTokenMaker
      - - org.fife.ui.rsyntaxtextarea.modes.JavaScriptTokenMaker

- All Implemented Interfaces:
    TokenMaker

      public class JavaScriptTokenMaker
      extends AbstractJFlexCTokenMaker

  Scanner for JavaScript files. Its states could be simplified, but are kept the way they are to keep a degree of similarity (i.e. copy/paste) between it and HTML/JSP/PHPTokenMaker. This should cause no difference in performance.

  This implementation was created using JFlex 1.4.1; however, the generated file was modified for performance. Memory allocation needs to be almost completely removed to be competitive with the handwritten lexers (subclasses of `AbstractTokenMaker`, so this class has been modified so that Strings are never allocated (via yytext()), and the scanner never has to worry about refilling its buffer (needlessly copying chars around). We can achieve this because RText always scans exactly 1 line of tokens at a time, and hands the scanner this line as an array of characters (a Segment really). Since tokens contain pointers to char arrays instead of Strings holding their contents, there is no need for allocating new memory for Strings.

  The actual algorithm generated for scanning has, of course, not been modified.

  If you wish to regenerate this file yourself, keep in mind the following:

  - The generated `JavaScriptTokenMaker.java` file will contain two definitions of both `zzRefill` and `yyreset`. You should hand-delete the second of each definition (the ones generated by the lexer), as these generated methods modify the input buffer, which we'll never have to do.
  - You should also change the declaration/definition of zzBuffer to NOT be initialized. This is a needless memory allocation for us since we will be pointing the array somewhere else anyway.
  - You should NOT call `yylex()` on the generated scanner directly; rather, you should use `getTokenList` as you would with any other `TokenMaker` instance.

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexCTokenMaker

      `AbstractJFlexCTokenMaker.CStyleInsertBreakAction`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static int` | `E4X`
    `static int` | `E4X_CDATA`
    `static int` | `E4X_COMMENT`
    `static int` | `E4X_DTD`
    `static int` | `E4X_INATTR_DOUBLE`
    `static int` | `E4X_INATTR_SINGLE`
    `static int` | `E4X_INTAG`
    `static int` | `E4X_PI`
    `static int` | `JS_CHAR`
    `static int` | `JS_DOCCOMMENT`
    `static int` | `JS_EOL_COMMENT`
    `static int` | `JS_MLC`
    `static int` | `JS_STRING` lexical states
    `static int` | `YYEOF` This character denotes the end of file
    `static int` | `YYINITIAL`

    - ### Fields inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker

      `offsetShift, s, start`

    - ### Fields inherited from class org.fife.ui.rsyntaxtextarea.TokenMakerBase

      `currentToken, firstToken, previousToken`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `JavaScriptTokenMaker()` Constructor.
    `JavaScriptTokenMaker(java.io.InputStream in)` Creates a new scanner.
    `JavaScriptTokenMaker(java.io.Reader in)` Creates a new scanner There is also a java.io.InputStream version of this constructor.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addToken(char[] array, int start, int end, int tokenType, int startOffset)` Adds the token specified to the current linked list of tokens.
    `int` | `getClosestStandardTokenTypeForInternalType(int type)` Returns the closest `"standard" token type` for a given "internal" token type (e.g.
    `static java.lang.String` | `getJavaScriptVersion()` Returns the JavaScript version being highlighted.
    `java.lang.String[]` | `getLineCommentStartAndEnd(int languageIndex)` Returns the text to place at the beginning and end of a line to "comment" it in this programming language.
    `Token` | `getTokenList(javax.swing.text.Segment text, int initialTokenType, int startOffset)` Returns the first token in the linked list of tokens generated from `text`.
    `static boolean` | `isE4xSupported()` Returns whether e4x is being highlighted.
    `static boolean` | `isJavaScriptCompatible(java.lang.String version)` Returns whether features for a specific JS version should be honored while highlighting.
    `static void` | `setE4xSupported(boolean supported)` Sets whether e4x should be highlighted.
    `static void` | `setJavaScriptVersion(java.lang.String javaScriptVersion)` Set the supported JavaScript version because some keywords were introduced on or after this version.
    `void` | `yybegin(int newState)` Enters a new lexical state
    `char` | `yycharat(int pos)` Returns the character at position `pos` from the matched text.
    `void` | `yyclose()` Closes the input stream.
    `int` | `yylength()` Returns the length of the matched text region.
    `Token` | `yylex()` Resumes scanning until the next regular expression is matched, the end of input is encountered or an I/O-Error occurs.
    `void` | `yypushback(int number)` Pushes the specified amount of characters back into the input stream.
    `void` | `yyreset(java.io.Reader reader)` Resets the scanner to read from a new input stream.
    `int` | `yystate()` Returns the current lexical state.
    `java.lang.String` | `yytext()` Returns the text matched by the current regular expression.

    - ### Methods inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexCTokenMaker

      `createInsertBreakAction, getCurlyBracesDenoteCodeBlocks, getInsertBreakAction, getMarkOccurrencesOfTokenType, getShouldIndentNextLineAfter`

    - ### Methods inherited from class org.fife.ui.rsyntaxtextarea.AbstractJFlexTokenMaker

      `yybegin`

    - ### Methods inherited from class org.fife.ui.rsyntaxtextarea.TokenMakerBase

      `addNullToken, addToken, addToken, createOccurrenceMarker, getLanguageIndex, getLastTokenTypeOnLine, getOccurrenceMarker, isIdentifierChar, isMarkupLanguage, resetTokenList, setLanguageIndex`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### YYEOF

          public static final int YYEOF

      This character denotes the end of file
      See Also:
        Constant Field Values

    - #### JS_STRING

          public static final int JS_STRING

      lexical states
      See Also:
        Constant Field Values

    - #### E4X

          public static final int E4X

      See Also:
        Constant Field Values

    - #### E4X_INTAG

          public static final int E4X_INTAG

      See Also:
        Constant Field Values

    - #### E4X_PI

          public static final int E4X_PI

      See Also:
        Constant Field Values

    - #### JS_MLC

          public static final int JS_MLC

      See Also:
        Constant Field Values

    - #### JS_CHAR

          public static final int JS_CHAR

      See Also:
        Constant Field Values

    - #### JS_EOL_COMMENT

          public static final int JS_EOL_COMMENT

      See Also:
        Constant Field Values

    - #### E4X_COMMENT

          public static final int E4X_COMMENT

      See Also:
        Constant Field Values

    - #### JS_DOCCOMMENT

          public static final int JS_DOCCOMMENT

      See Also:
        Constant Field Values

    - #### E4X_DTD

          public static final int E4X_DTD

      See Also:
        Constant Field Values

    - #### E4X_INATTR_SINGLE

          public static final int E4X_INATTR_SINGLE

      See Also:
        Constant Field Values

    - #### E4X_INATTR_DOUBLE

          public static final int E4X_INATTR_DOUBLE

      See Also:
        Constant Field Values

    - #### YYINITIAL

          public static final int YYINITIAL

      See Also:
        Constant Field Values

    - #### E4X_CDATA

          public static final int E4X_CDATA

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### JavaScriptTokenMaker

          public JavaScriptTokenMaker()

      Constructor. This must be here because JFlex does not generate a no-parameter constructor.

    - #### JavaScriptTokenMaker

          public JavaScriptTokenMaker(java.io.Reader in)

      Creates a new scanner There is also a java.io.InputStream version of this constructor.
      Parameters:
        `in` - the java.io.Reader to read input from.

    - #### JavaScriptTokenMaker

          public JavaScriptTokenMaker(java.io.InputStream in)

      Creates a new scanner. There is also java.io.Reader version of this constructor.
      Parameters:
        `in` - the java.io.Inputstream to read input from.

  - ### Method Detail

    - #### addToken

          public void addToken(char[] array,
                      int start,
                      int end,
                      int tokenType,
                      int startOffset)

      Adds the token specified to the current linked list of tokens.
      Specified by:
        `addToken` in interface `TokenMaker`
      Overrides:
        `addToken` in class `TokenMakerBase`
      Parameters:
        `array` - The character array.
        `start` - The starting offset in the array.
        `end` - The ending offset in the array.
        `tokenType` - The token's type.
        `startOffset` - The offset in the document at which this token occurs.

    - #### getClosestStandardTokenTypeForInternalType

          public int getClosestStandardTokenTypeForInternalType(int type)

      Returns the closest `"standard" token type` for a given "internal" token type (e.g. one whose value is `< 0`).
      Specified by:
        `getClosestStandardTokenTypeForInternalType` in interface `TokenMaker`
      Overrides:
        `getClosestStandardTokenTypeForInternalType` in class `TokenMakerBase`
      Parameters:
        `type` - The token type.
      Returns:
        The closest "standard" token type.

    - #### getJavaScriptVersion

          public static java.lang.String getJavaScriptVersion()

      Returns the JavaScript version being highlighted.
      Returns:
        Supported JavaScript version.
      See Also:
        `isJavaScriptCompatible(String)`

    - #### getLineCommentStartAndEnd

          public java.lang.String[] getLineCommentStartAndEnd(int languageIndex)

      Returns the text to place at the beginning and end of a line to "comment" it in this programming language.
      Specified by:
        `getLineCommentStartAndEnd` in interface `TokenMaker`
      Overrides:
        `getLineCommentStartAndEnd` in class `TokenMakerBase`
      Parameters:
        `languageIndex` - The language index at the offset in question. Since some `TokenMaker`s effectively have nested languages (such as JavaScript in HTML), this parameter tells the `TokenMaker` what sub-language to look at.
      Returns:
        The start and end strings to add to a line to "comment" it out. A `null` value for either means there is no string to add for that part. A value of `null` for the array means this language does not support commenting/uncommenting lines.

    - #### getTokenList

          public Token getTokenList(javax.swing.text.Segment text,
                           int initialTokenType,
                           int startOffset)

      Returns the first token in the linked list of tokens generated from `text`. This method must be implemented by subclasses so they can correctly implement syntax highlighting.
      Parameters:
        `text` - The text from which to get tokens.
        `initialTokenType` - The token type we should start with.
        `startOffset` - The offset into the document at which `text` starts.
      Returns:
        The first `Token` in a linked list representing the syntax highlighted text.

    - #### isE4xSupported

          public static boolean isE4xSupported()

      Returns whether e4x is being highlighted.
      Returns:
        Whether e4x is being highlighted.
      See Also:
        `setE4xSupported(boolean)`

    - #### isJavaScriptCompatible

          public static boolean isJavaScriptCompatible(java.lang.String version)

      Returns whether features for a specific JS version should be honored while highlighting.
      Parameters:
        `version` - JavaScript version required
      Returns:
        Whether the JavaScript version is the same or greater than version required.

    - #### setE4xSupported

          public static void setE4xSupported(boolean supported)

      Sets whether e4x should be highlighted. A repaint should be forced on all `RSyntaxTextArea`s editing JavaScript if this property is changed to see the difference.
      Parameters:
        `supported` - Whether e4x should be highlighted.
      See Also:
        `isE4xSupported()`

    - #### setJavaScriptVersion

          public static void setJavaScriptVersion(java.lang.String javaScriptVersion)

      Set the supported JavaScript version because some keywords were introduced on or after this version.
      Parameters:
        `javaScriptVersion` - The version of JavaScript to support, such as "`1.5`" or "`1.6`".
      See Also:
        `isJavaScriptCompatible(String)`, `getJavaScriptVersion()`

    - #### yyreset

          public final void yyreset(java.io.Reader reader)

      Resets the scanner to read from a new input stream. Does not close the old reader. All internal variables are reset, the old input stream cannot be reused (internal buffer is discarded and lost). Lexical state is set to `YY_INITIAL`.
      Parameters:
        `reader` - the new input stream

    - #### yyclose

          public final void yyclose()
                             throws java.io.IOException

      Closes the input stream.
      Throws:
        `java.io.IOException`

    - #### yystate

          public final int yystate()

      Returns the current lexical state.

    - #### yybegin

          public final void yybegin(int newState)

      Enters a new lexical state
      Specified by:
        `yybegin` in class `AbstractJFlexTokenMaker`
      Parameters:
        `newState` - the new lexical state

    - #### yytext

          public final java.lang.String yytext()

      Returns the text matched by the current regular expression.

    - #### yycharat

          public final char yycharat(int pos)

      Returns the character at position `pos` from the matched text. It is equivalent to yytext().charAt(pos), but faster
      Parameters:
        `pos` - the position of the character to fetch. A value from 0 to yylength()-1.
      Returns:
        the character at position pos

    - #### yylength

          public final int yylength()

      Returns the length of the matched text region.

    - #### yypushback

          public void yypushback(int number)

      Pushes the specified amount of characters back into the input stream. They will be read again by then next call of the scanning method
      Parameters:
        `number` - the number of characters to be read again. This number must not be greater than yylength()!

    - #### yylex

          public Token yylex()
                      throws java.io.IOException

      Resumes scanning until the next regular expression is matched, the end of input is encountered or an I/O-Error occurs.
      Returns:
        the next token
      Throws:
        `java.io.IOException` - if any I/O-Error occurs